<?php
/**
 * Topics Anywhere for phpBB 3.0.x is a fork of Topics Anywhere
 * The original version can be download here : http://www.afsvlaanderen.be/topics_anywhere/download.php
 *
 * @author (original version) DtM < dtm@yucom.be > (Dennis Heeren) http://www.afsvlaanderen.be/topics_anywhere 
 * @author (fork) Simon Leblanc <contact@leblanc-simon.eu>
 *
 */
 
/**
*
* @package phpBB3
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);


//
// Config Section
//

// Who may view the Topics Anywhere setup page and generate scripts to copy and paste?
// Everybody: 0
// Administrators only: 1
// Moderators only: 2
// Administrators and moderators: 3
// All registered users: 4
$topics_anywhere_authlevel = 0;

// By default, only public forums are shown in the picklist. If you want, you can let
// Topics Anywhere show all forums in the picklist (this is including private and hidden forums).
// To do this, change 'true' to 'false' below.
// You can still exclude specific forums from the picklist by changing next config option.
$public_only = true;

// Don't show following forums in the picklist on the setup page.
// This is an array of numbers which are the forum ID's.
// For example use "$hide_forums = array(1, 5, 10);" to hide forums with ID 1, 5 and 10
// Leave the array empty (as below) to show all the forums.
// Note: it is never possible to let Topics Anywhere show topics from excluded forums,
// not even by modifying the URL generated by Topics Anywhere.
$hide_forums = array();

// You can change the format of date and time here...
// For American type dates you probably want to use the other array below
// You can also make your own formats, as long as you use the syntax of PHP's function date()
// Of course, do not add or remove any quotes! (unless escaped)
$date_formats = array('d/m/y', 'd/m/Y', 'd/m/Y H:i:s', 'D d-M-y', 'D d-M-Y', 'D d-M-Y H:i:s', 'l j F Y', 'l j F Y H:i:s');

// Some American style date formats - to enable them uncomment following line by removing the '// '
// $date_formats = array('m/d/y', 'm/d/Y', 'm/d/Y g:i:s A', 'D M d, y', 'D M d, Y', 'D M d, Y g:i:s A', 'l, F jS, Y', 'l, F jS, Y g:i:s A');

// Array of possible bullets
// You can add your own bullets if you want.
// Do not add or remove any quotes! (unless escaped)
$bullets = array('-', '+', '&gt;', '&#155;', '&#187;', '°', '*');



// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/info_ucp_topic_anywhere');
// End session management


$server_protocol = $config['server_protocol'];
$server_name = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($config['server_name']));
$server_port = (isset($config['server_port']) && $config['server_port'] <> 80) ? ':' . trim($config['server_port']) : '';
$script_location = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($config['script_path']));
$script_location = ($script_location == '') ? $script_location : '/' . $script_location;

$full_url = $server_protocol . $server_name . $server_port . $script_location;

$lang = array_merge($user->lang, array('TOPICS_ANYWHERE' => 'Topics Anywhere for phpBB 3.0.x', 'ENCODING' => 'UTF-8'));

define('TA_SCRIPT_NAME', 'topic_anywhere_phpbb3');
define('TA_VERSION', '1.0.0');

$lastpostby_formats = array($lang['USERNAME'], $lang['LASTPOST_FROM'] . ' ' . $lang['USERNAME']);


// General functions
function output_die($msg)
{
    global $out, $phpEx, $full_url, $version;

    $error = true;

    if ($out == 'js')
    {
        if (is_array($msg))
        {
            $output = implode('<br>', $msg);
        }
        else
        {
            $output = $msg;
        }

        $output = '<b>' . $output . '<br>' . sprintf($lang['Error'], TA_SCRIPT_NAME . $phpEx) . '</b><br><br>TA_VERSION ' . TA_VERSION;
        exit("document.writeln('$output');\n");
    }
    else if ($out == 'rss')
    {
        $output = generate_rss_header($version);

        $link = ($version == '0.91') ? substr($full_url, 0, 500) : $full_url;

        if (is_array($msg))
        {
            while ($error = array_shift($msg))
            {
                $output .= '<item>' . "\n";;
                $output .= '<title>' . $error . '</title>' . "\n";
                $output .= '<link>' . $link . '</link>' . "\n";
                $output .= '<description>' . sprintf($lang['Error'], TA_SCRIPT_NAME . $phpEx) . ' (TA_VERSION ' . TA_VERSION . ')</description>' . "\n";
                $output .= '</item>' . "\n";
            }
        }
        else
        {
            $output .= '<item>' . "\n";;
            $output .= '<title>' . $msg . '</title>' . "\n";
            $output .= '<link>' . $link . '</link>' . "\n";
            $output .= '<description>' . sprintf($lang['Error'], TA_SCRIPT_NAME . $phpEx) . ' (TA_VERSION ' . TA_VERSION . ')</description>' . "\n";
            $output .= '</item>' . "\n";
        }

        $output .= generate_rss_footer();

        header("Content-type: text/xml");
        exit($output);
    }
}

function gen_space($count = 0)
{
    $space = '';
    for ($i = 0; $i < $count; $i++) {
        $space .= '&nbsp;&nbsp;';
    }
    
    return $space;
}


function forum_select() // generates select of all available forums (modified make_jumpbox()-function)
{
    // TA : global $template, $lang, $db, $SID, $nav_links, $phpEx, $hide_forums;
        global $config, $auth, $template, $user, $db;

    $sql = 'SELECT forum_id, forum_name, parent_id, forum_type, left_id, right_id
        FROM ' . FORUMS_TABLE . '
        ORDER BY left_id ASC';
    $result = $db->sql_query($sql, 600);

    $right = $padding = 0;
    $padding_store = array('0' => 0);
    $display_jumpbox = false;
    $iteration = 0;
        $boxstring = '';

        while ($row = $db->sql_fetchrow($result))
    {
        if ($row['left_id'] < $right)
        {
            $padding++;
            $padding_store[$row['parent_id']] = $padding;
        }
        else if ($row['left_id'] > $right + 1)
        {
            // Ok, if the $padding_store for this parent is empty there is something wrong. For now we will skip over it.
            // @todo digging deep to find out "how" this can happen.
            $padding = (isset($padding_store[$row['parent_id']])) ? $padding_store[$row['parent_id']] : $padding;
        }

        $right = $row['right_id'];

        if ($row['forum_type'] == FORUM_CAT && ($row['left_id'] + 1 == $row['right_id']))
        {
            // Non-postable forum with no subforums, don't display
            continue;
        }

        if (!$auth->acl_get('f_list', $row['forum_id']))
        {
            // if the user does not have permissions to list this forum skip
            continue;
        }

        if ($acl_list && !$auth->acl_gets($acl_list, $row['forum_id']))
        {
            continue;
        }

        $boxstring .= '<option value="'.$row['forum_id'].'">'.gen_space($padding).$row['forum_name'].'</option>';
                
        $iteration++;
    }
    $db->sql_freeresult($result);
    unset($padding_store);
        $total_forums = $iteration;
        
        if ($iteration > 0) {
            $boxstring = '<select multiple name="f[]" size=6>'.$boxstring.'</select>';
        } else {
            $boxstring = '<select multiple name="f[]" size=1></select>';
        }
        
    $data = array($boxstring, $total_forums);
    return $data;
}


function bullet_select($bullets) // generates select of all available bullets from array $bullets
{
    global $lang;
    $select = '<select name="bullet_type">';
    $select .= '<option value="non">' . $lang['None'] . '</option>';
    $select .= '<option value="dis">HTML ' . $lang['disc'] . '</option>';
    $select .= '<option value="cir">HTML ' . $lang['circle'] . '</option>';
    $select .= '<option value="squ">HTML ' . $lang['square'] . '</option>';
    $select .= '<option value="num">HTML ' . $lang['numbered'] . '</option>';
    for ($i = 0; $i < count($bullets); $i++)
    {
        $select .= '<option value="' . $i . '">' . $bullets[$i] . '</option>';
    }
    $select .= '</select>';
    return $select;
}


function lastpostby_select($lastpostby_formats) // generates select of "last post by" text formats
{
    global $lang;
    $select = '<select name="lastpostby_format">';
    for ($i = 0; $i < count($lastpostby_formats); $i++)
    {
        $select .= '<option value="' . $i . '">' . $lastpostby_formats[$i] . '</option>';
    }
    $select .= '</select>';
    return $select;
}


function lastpostdate_select($date_formats) // generates select of date formats from array $dateformats
{
    global $lang, $user;
    $now = time();
    $select = '<select name="lastpostdate_format">';
    for ($i = 0; $i < count($date_formats); $i++)
    {
        $select .= '<option value="' . $i . '">' . $user->format_date($now, $date_formats[$i]) . '</option>';
    }
    $select .= '</select>';
    return $select;
}


function output_select()
{
    $select = '<select name="out">';
    //$select .= '<option value="js">JavaScript</option>';
    $select .= '<option value="rss0.91">RSS 0.91</option>';
    $select .= '<option value="rss2.0" selected="selected">RSS 2.0</option>';
    $select .= '</select>';
    return $select;
}


function show_the_page()
{
    global $template, $lang, $db, $SID, $nav_links, $phpEx, $phpbb_root_path, $theme, $images, $date_formats, $lastpostby_formats, $bullets, $board_config, $full_url, $user;

    $page_title = 'Topics_anywhere';

    $outputarray = forum_select();

    $html_allowed_append = ' (' . strip_tags($lang['HTML_IS_OFF']) . ')';

    $template->assign_vars(array(
        'L_TOPICS_ANYWHERE' => $lang['TOPICS_ANYWHERE'] . ' ' . TA_VERSION,
        'L_TOPICS_ANYWHERE_EXPLAIN' => $lang['TOPICS_ANYWHERE_EXPLAIN'] . ' ' . $lang['TOPICS_ANYWHERE_EXPLAIN_MORE'],
        'L_OUTPUT' => $lang['OUTPUT'],
        'L_OUTPUT_EXPLAIN' => $lang['OUTPUT_EXPLAIN'],
        'OUTPUT_SELECT' => output_select($languages, $langs),
        'L_SELECT_FORUM' => $lang['FORUM_SELECT'] . $lang['CATEGORY_SELECT'],
        'L_SELECT_FORUM_EXPLAIN' => $lang['SELECT_FORUM_EXPLAIN'] . $lang['CATEGORY_EXPLAIN'],
        'SELECT_FORUM_SELECT' => $outputarray[0],
        'L_OR' => $lang['OR'],
        'L_CHECK_ALLFORA' => $lang['ALL_AVAILABLE'],
        'L_AMOUNT_TOPICS' => $lang['AMOUNT_TOPICS'],
        'L_AMOUNT_TOPICS_EXPLAIN' => $lang['AMOUNT_TOPICS_EXPLAIN'],
        'L_TOPICS_LIFESPAN' => $lang['TOPICS_LIFESPAN'],
        'L_TOPICS_LIFESPAN_EXPLAIN' => $lang['TOPICS_LIFESPAN_EXPLAIN'],
        'L_TOPICS_LIFESPAN_NOREPLY' => $lang['TOPICS_LIFESPAN_NOREPLY'],
        'L_TOPICS_LIFESPAN_STARTDATE' => $lang['TOPICS_LIFESPAN_STARTDATE'],
        'L_HOURS' => strtolower($lang['HOURS']),
        'L_DAYS' => strtolower($lang['DAYS']),
        'L_JUMP_LAST_POST' => $lang['URL_LAST_POST'],
        'L_JUMP_LAST_POST_EXPLAIN' => $lang['URL_LAST_POST_EXPLAIN'],
        'L_SHOW_FORUM_NAME' => $lang['SHOW_FORUM_NAME'],
        'L_SHOW_FORUM_NAME_EXPLAIN' => $lang['SHOW_FORUM_NAME_EXPLAIN'],
        'L_LINK_FORUM_NAME' => $lang['LINK_FORUM_NAME'],
        'L_LINK_FORUM_NAME_EXPLAIN' => $lang['LINK_FORUM_NAME_EXPLAIN'] . ' (*)',
        'L_SHOW_REPLIES' => $lang['SHOW_REPLIES'],
        'L_SHOW_REPLIES_EXPLAIN' => $lang['SHOW_REPLIES_EXPLAIN'],
        'L_SHOW_REPLIES_WORD' => $lang['SHOW_REPLIES_WORD'],
        'L_SHOW_REPLIES_WORD_EXPLAIN' => $lang['SHOW_REPLIES_WORD_EXPLAIN'],
        'L_SHOW_ANNOUNCEMENTS' => $lang['SHOW_ANNOUNCE'],
        'L_SHOW_STICKYS' => $lang['SHOW_STICKY'],
        'L_SHOW_LOCKED' => $lang['SHOW_LOCKED'],
        'L_SHOW_MOVED' => $lang['SHOW_MOVED'],
        'L_SHOW_REGULAR' => $lang['SHOW_REGULAR'],
        'L_HIDE_LABELS' => $lang['HIDE_LABELS'],
        'L_HIDE_LABELS_EXPLAIN' => $lang['HIDE_LABELS_EXPLAIN'],
        'O_ANNOUNCEMENT' => strip_tags($lang['TOPIC_ANNOUNCEMENT']),
        'O_STICKY' => strip_tags($lang['TOPIC_STICKY']),
        'O_MOVED' => strip_tags($lang['TOPIC_MOVED']),
        'O_POLL' => strip_tags($lang['TOPIC_POLL']),
        'O_LOCKED' => strip_tags($lang['TOPIC_LOCKED']),
        'L_SORT_ORDER' => $lang['SORT_ORDER'],
        'L_SORT_ORDER_EXPLAIN' => $lang['SORT_ORDER_EXPLAIN'],
        'O_PRIORITY' => $lang['PRIORITY'],
        'O_ON_DATE' => $lang['ON_DATE'],
        'L_BULLET_TYPE' => $lang['BULLET_TYPE'],
        'L_BULLET_TYPE_EXPLAIN' => $lang['BULLET_TYPE_EXPLAIN'] . ' (*)',
        'BULLET_TYPE_SELECT' => bullet_select($bullets),
        'L_SHOW_LASTPOSTBY' => $lang['SHOW_LASTPOSTBY'],
        'L_SHOW_LASTPOSTBY_EXPLAIN' => $lang['SHOW_LASTPOSTBY_EXPLAIN'],
        'L_LASTPOSTBY_FORMAT' => $lang['LASTPOSTBY_FORMAT'],
        'L_LASTPOSTBY_FORMAT_EXPLAIN' => $lang['LASTPOSTBY_FORMAT_EXPLAIN'],
        'LASTPOSTBY_FORMAT_SELECT' => lastpostby_select($lastpostby_formats),
        'L_SHOW_LASTPOSTDATE' => $lang['SHOW_LASTPOSTDATE'],
        'L_SHOW_LASTPOSTDATE_EXPLAIN' => $lang['SHOW_LASTPOSTDATE_EXPLAIN'],
        'L_LASTPOSTDATE_FORMAT' => $lang['LASTPOSTDATE_FORMAT'],
        'L_LASTPOSTDATE_FORMAT_EXPLAIN' => $lang['LASTPOSTDATE_FORMAT_EXPLAIN'],
        'LASTPOSTDATE_FORMAT_SELECT' => lastpostdate_select($date_formats),
        'L_SHOW_LASTPOSTICON' => $lang['SHOW_LASTPOSTICON'],
        'L_SHOW_LASTPOSTICON_EXPLAIN' => $lang['SHOW_LASTPOSTICON_EXPLAIN'] . ' (*)',
        'L_LASTPOSTICON_AS_BULLET' => $lang['LASTPOSTICON_AS_BULLET'],
        'L_LASTPOSTICON_AS_BULLET_EXPLAIN' => $lang['LASTPOSTICON_AS_BULLET_EXPLAIN'] . ' (*)',
        'L_ADD_BREAK' => $lang['ADD_BREAK'],
        'L_ADD_BREAK_EXPLAIN' => $lang['ADD_BREAK_EXPLAIN'] . ' (*)',
        'L_ADD_BLANK_LINE' => $lang['ADD_BLANK_LINE'],
        'L_ADD_BLANK_LINE_EXPLAIN' => $lang['ADD_BLANK_LINE_EXPLAIN'] . ' (*)',
        'L_LIMIT_LENGTH' => $lang['LIMIT_TITLE_LENGTH'],
        'L_LIMIT_LENGTH_EXPLAIN' => $lang['LIMIT_TITLE_LENGTH_EXPLAIN'],
        'L_LIMIT_WHERE' => $lang['LIMIT_TITLE_WHERE'],
        'L_LIMIT_WHERE_EXPLAIN' => $lang['LIMIT_TITLE_WHERE_EXPLAIN'],
        'L_PREVIOUS_SPACE' => $lang['LIMIT_TITLE_PREVIOUS_SPACE'],
        'L_EXACT' => $lang['LIMIT_TITLE_EXACT'],
        'L_NEXT_SPACE' => $lang['LIMIT_TITLE_NEXT_SPACE'],
        'L_CSS_LINK' => $lang['CSS_LINK'],
        'L_CSS_LINK_EXPLAIN' => $lang['CSS_LINK_EXPLAIN'] . ' (*)',
        'L_CSS_TEXT' => $lang['CSS_TEXT'],
        'L_CSS_TEXT_EXPLAIN' => $lang['CSS_TEXT_EXPLAIN'] . ' (*)',
        'L_TARGET_LINK' => $lang['TARGET_LINK'],
        'L_TARGET_LINK_EXPLAIN' => $lang['TARGET_LINK_EXPLAIN'] . ' (*)',
        'L_ADV_FORM' => $lang['ADVANCED_FORMATTER'],
        'L_ADV_FORM_EXPLAIN' => $lang['ADVANCED_FORMATTER_EXPLAIN'],
        'L_ADV_FORM_STRING' => $lang['ADVANCED_FORMATTER_STRING'],
        'L_ADV_FORM_STRING_EXPLAIN' => $lang['ADVANCED_FORMATTER_STRING_EXPLAIN'],
        'L_ADV_FORM_DEFAULT' => '§lbl§ §tt§ §fn§ §rep§ - §lpa§, §lpt§ §lpi§',
        'L_ADV_FORM_VARS' => $lang['ADVANCED_FORMATTER_VARIABLES'] . '<br /><br />' . $lang['ADVANCED_FORMATTER_VARIABLES_EXTRA'] . $html_allowed_append,
        'L_YES' => $lang['YES'],
        'L_NO' => $lang['NO'],
        'L_SUBMIT' => $lang['SUBMIT'],
        'L_RESET' => $lang['RESET'],
        'H_TOTAL_FORUMS' => $outputarray[1],
        'S_FORM_ACTION' => append_sid(TA_SCRIPT_NAME . ".$phpEx?mode=generate"))
    );

    page_header($page_title);
        
        $template->set_filenames(array(
                'body' => 'topics_anywhere_body.html')
        );
        $template->set_template();
        
        make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));
        page_footer();
}


function generate_rss_header($version)
{
    global $db, $lang, $config, $full_url;

    $sql = "SELECT theme_name
        FROM " . STYLES_THEME_TABLE . "
        WHERE theme_id = " . $config['default_style'];
    if ( !($result = $db->sql_query($sql)) )
    {
        trigger_error('Could not query database for theme info', E_USER_ERROR);
    }

    if ( !($row = $db->sql_fetchrow($result)) )
    {
        trigger_error('Could not get theme data for themes_id ['.$style.']', E_USER_ERROR);
    }

    $dir = $row['theme_name'];

    $langs = array('albanian', 'arabic', 'bulgarian', 'catalan', 'chinese_simplified', 'chinese_traditional', 'croatian', 'czech', 'danish', 'dutch', 'english', 'finnish', 'french', 'galego', 'german', 'german_sie', 'greek', 'hebrew', 'hungarian', 'icelandic', 'indonesian', 'italian', 'japanese', 'korean', 'kurdish', 'lithuanian', 'macedonian', 'norwegian', 'polish', 'portuguese', 'portuguese_brazil', 'romanian', 'romanian_no_diacritics', 'russian', 'russian_tu', 'serbian', 'slovak', 'slovenian', 'spanish', 'spanish_argentina', 'swedish', 'thai', 'turkish', 'ukrainian', 'welsh');
    $codes = array('SQ', 'AR', 'BG', 'CA', 'ZH-CN', 'ZH-TW', 'HR', 'CS', 'DA', 'NL', 'EN', 'FI', 'FR', 'GL', 'DE', 'DE', 'EL', 'HE', 'HU', 'IS', 'ID', 'IT', 'JA', 'KO', 'KU', 'LT', 'MK', 'NO', 'PL', 'PT', 'PT-BR', 'RO', 'RO', 'RU', 'RU', 'SR', 'SK', 'SL', 'ES', 'ES-AR', 'SV', 'TH', 'TR', 'UK', 'CY');

    if (($index = array_search($config['default_lang'], $langs)) !== FALSE) {
        $langcode = strtolower($codes[$index]);
    }
    else
    {
        $langcode = 'en';
    }

    unset($langs, $codes, $index);

    $title = ($version == '0.91') ? substr($config['sitename'], 0, 100) : $config['sitename'];
    $link = ($version == '0.91') ? substr($full_url, 0, 500) : $full_url;
    $description = ($version == '0.91') ? substr($config['site_desc'], 0, 500) : $config['site_desc'];
    $url = ($version == '0.91') ? substr(($full_url . '/styles/' . $dir . '/imageset/site_logo.gif'), 0, 500) : ($full_url . '/styles/' . $dir . '/imageset/site_logo.gif');
    $copy = ($version == '0.91') ? substr(('Copyright ' . date('Y', $config['board_startdate']) . '-' . date('Y') . ', ' . $config['sitename']), 0, 100) : ('Copyright ' . date('Y', $config['board_startdate']) . '-' . date('Y') . ', ' . $config['sitename']);
    $mail = ($version == '0.91') ? substr($config['board_email'], 0, 100) : $config['board_email'];
    $docs = ($version == '0.91') ? 'http://backend.userland.com/stories/rss091' : 'http://blogs.law.harvard.edu/tech/rss';
    $date = date('r');

    $output = '<?xml version="1.0" encoding="' . $lang['ENCODING'] . '" ?>' . "\n";
    $output .= '<rss version="' . $version . '" xmlns:dc="http://purl.org/dc/elements/1.1/">' . "\n";
    $output .= '<channel>' . "\n";
    $output .= '<title>' . $title . '</title>' . "\n";
    $output .= '<link>' . $link . '</link>' . "\n";
    $output .= '<description>' . $description . '</description>' . "\n";
    $output .= '<language>' . $langcode . '</language>' . "\n";
    $output .= '<managingEditor>' . $mail . '</managingEditor>' . "\n";
    $output .= '<webMaster>' . $mail . '</webMaster>' . "\n";
    $output .= '<pubDate>' . $date . '</pubDate>' . "\n";
    $output .= '<lastBuildDate>' . $date . '</lastBuildDate>' . "\n";
    $output .= '<copyright>' . $copy . '</copyright>' . "\n";

    if ($version == '2.0')
    {
        $output .= '<generator>' . $lang['TOPICS_ANYWHERE'] . ' ' . TA_VERSION . '</generator>' . "\n";
    }

    $output .= '<docs>' . $docs . '</docs>' . "\n";

    $output .= '<image>' . "\n";
    $output .= '<url>' . $url . '</url>' . "\n";
    $output .= '<title>' . $title . '</title>' . "\n";
    $output .= '<link>' . $link . '</link>' . "\n";
    $output .= '</image>' . "\n";

    return $output;
}


function generate_rss_footer()
{
    $output = '</channel>' . "\n";
    $output .= '</rss>' . "\n";

    return $output;
}


function select_hide_forums()
{
    global $db, $auth;
    $hide_forums = array();
    
    $sql = 'SELECT forum_id FROM '.FORUMS_TABLE;
    if (!($result = $db->sql_query($sql))) {
        trigger_error('Could not query forum_id SQL', E_USER_ERROR);
    }
    
    while ($row = $db->sql_fetchrow($result)) {
        if ($auth->acl_get('f_read', $row['forum_id']) === 0) {
            $hide_forums[] = $row['forum_id'];
        }
    }
    
    return $hide_forums;
}


function get_forums_child($forum_id)
{
    global $db, $auth;
    $child = array();
    
    if (!is_numeric($forum_id)) {
        return $child;
    }
    
    $sql = 'SELECT forum_id
            FROM '.FORUMS_TABLE.'
            WHERE parent_id = '.(int) $forum_id;
    if (!($result = $db->sql_query($sql))) {
        trigger_error('Could not query subforum', E_USER_ERROR);
    }
    
    while ($row = $db->sql_fetchrow($result)) {
        $child[] = $row['forum_id'];
        // check if this subforum haven't child
        $sub_child = get_forums_child($row['forum_id']);
        if (count($sub_child) > 0) {
            $child = array_merge($child, $sub_child);
        }
    }
    
    return $child;
}


################################################################################
#
#               MAIN PROGRAM
#
################################################################################
$mode = request_var('mode', 'config');

if ($public_only) {
    $hide_forums = select_hide_forums();
}

if ($mode === 'show') {
    // Output mode check
    $out = request_var('out', 'js');
    if ($out === 'rss0.91') {
        $out = 'rss';
        $version = '0.91';
    } else if ($out === 'rss2.0') {
        $out = 'rss';
        $version = '2.0';
    }
    
    // Board is disabled, no topics are available
    if ($config['board_disable']) {
        if ($out == 'js') {
            $css_text_wrap_before = '';
            $css_text_wrap_after = '';
            $ct = request_var('ct', null);
            if ($ct !== null) {
                if ($ct != '') {
                    $css_text_wrap_before = '<span class=\"' . $ct . '\">';
                    $css_text_wrap_after = '</span>';
                } else {
                    $error = true;
                    trigger_error('Error: No value for argument (css_text)');
                }
            }
            
            $msg = $css_text_wrap_before . $lang['board_disable'] . $css_text_wrap_after;
            exit("document.writeln('$msg');\n");
        } else if ($out = 'rss') {
            $output = generate_rss_header($version);
            
            $title = ($version == '0.91') ? substr($lang['BOARD_DISABLE'], 0, 100) : $lang['BOARD_DISABLE'];
            $link = ($version == '0.91') ? substr($full_url, 0, 500) : $full_url;
            
            $output .= '<item>' . "\n";
            $output .= '<title>' . $title . '</title>' . "\n";
            $output .= '<link>' . $link . '</link>' . "\n";
            $output .= '</item>' . "\n";
            
            $output .= generate_rss_footer();
            header("Content-type: text/xml");
            exit($output);
        }
    }
    
    // Get most important vars out parameters
    $error = false;
    $errorarray = array();
    
    $adv_format = false;
    $af = request_var('af', '');
    if ($af !== '') {
        $adv_format = true;
        $af_string = base64_decode(rawurldecode($af));
    }
    
    $f = request_var('f', '0');
    if ($f === '0') {
        $error = true;
        array_push($errorarray, 'Error: Missing argument (forum_id)');
    } else {
        if (is_numeric($f)) {
            if ($auth->acl_get('f_read', $f) === 0) {
                    $error = true;
                    array_push($errorarray, 'Error: Not allowed to show topics from this forum');
            } else {
                $forum_id = (int) $f;
                $forum_sql = "AND t.forum_id = $forum_id";
            }
        } else {
            if ($f == 'a') {
                if (sizeof($hide_forums)) {
                    $hidelist = '(' . implode(', ', $hide_forums) . ')';
                    $forum_sql = 'AND t.forum_id NOT IN ' . $hidelist;
                } else {
                    $forum_sql = '';
                }
            } else {
                if (substr($f, 0, 1) == 'u') {
                    $forumlist = base64_decode(rawurldecode(substr($f, 1)));
                    $forumlist = '(' . str_replace(',', ', ', $forumlist) . ')';
                    $forum_sql = "AND t.forum_id in $forumlist";
                } else {
                    if (substr($f, 0, 1) == 'b') {
                        $forumlist = base64_decode(substr($f, 1));
                        $forum_sql = "AND t.forum_id in $forumlist";
                    } else {
                        $error = true;
                        array_push($errorarray, 'Error: Wrong argument (forum_id)');
                    }
                }
            }
        }
    }
    
    $n = request_var('n', '');
    if ($n === '') {
        $error = true;
        array_push($errorarray, 'Error: Missing argument (limit)');
    } else {
        if (is_numeric($n)) {
            $limit = (int) $n;
        } else {
            $error = true;
            array_push($errorarray, 'Error: Wrong argument (limit)');
        }
    }
    
    if (!$error) {
        $noreply_sql = '';
        $hnr = request_var('hnr', '');
        if ($hnr !== '') {
            if (is_numeric($hnr)) {
                $noreply = time() - (int) $hnr * 100;
                $noreply_sql = 'AND p2.post_time > ' . $noreply;
            } else {
                $error = true;
                trigger_error('Error: Wrong value for argument (no reply)');
            }
        }
        
        $startdate_sql = '';
        $hsd = request_var('hsd', '');
        if ($hsd !== '') {
            if (is_numeric($hsd)) {
                $startdate = time() - (int) $hsd * 100;
                $startdate_sql = 'AND p.post_time > ' . $startdate;
            } else {
                $error = true;
                trigger_error('Error: Wrong value for argument (start date)');
            }
        }
        
        $a = request_var('a', '');
        if ($a !== '') {
            if ($a == 'y') {
                $announce_sql = '';
            } else {
                $error = true;
                trigger_error('Error: Wrong value for argument (announcement)');
            }
        } else {
            $announce_sql = 'AND t.topic_type <> ' . POST_ANNOUNCE;
        }
        
        $s = request_var('s', '');
        if ($s !== '') {
            if ($s == 'y') {
                $sticky_sql = '';
            } else {
                $error = true;
                trigger_error('Error: Wrong value for argument (sticky)');
            }
        } else {
            $sticky_sql = "AND t.topic_type <> " . POST_STICKY;
        }
        
        $l = request_var('l', '');
        if ($l !== '') {
            if ($l == 'y') {
                $locked_sql = '';
            } else {
                $error = true;
                trigger_error('Error: Wrong value for argument (locked)');
            }
        } else {
            $locked_sql = "AND t.topic_status <> " . ITEM_LOCKED;
        }
        
        $m = request_var('m', '');
        if ($m !== '') {
            if ($m == 'y') {
                $locked_sql = '';
            } else {
                $error = true;
                trigger_error('Error: Wrong value for argument (moved)');
            }
        } else {
            $moved_sql = "AND t.topic_status <> " . ITEM_MOVED;
        }
        
        $rt = request_var('rt', '');
        if ($rt !== '') {
            if ($rt == 'n') {
                $reg_sql = "AND t.topic_type <> " . POST_NORMAL;
            } else {
                $error = true;
                trigger_error('Error: Wrong value for argument (regular topics)');
            }
        } else {
            $reg_sql = '';
        }
        
        $so = request_var('so', '');
        if ($so == 'd') {
            $sql = 'SELECT t.*, u.username, u.user_id, u2.username as user2, u2.user_id as id2, p.post_username, p2.post_username AS post_username2, p2.post_time, f.forum_name
                    FROM ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u, ' . POSTS_TABLE . ' p, ' . POSTS_TABLE . ' p2, ' . USERS_TABLE . ' u2, ' . FORUMS_TABLE . ' f
                    WHERE t.topic_poster = u.user_id '.
                    $forum_sql.'
                    AND p.post_id = t.topic_first_post_id
                    AND p2.post_id = t.topic_last_post_id
                    AND t.forum_id = f.forum_id
                    AND u2.user_id = p2.poster_id'.
                    $noreply_sql.' '.
                    $startdate_sql.' '.
                    $announce_sql.' '.
                    $sticky_sql.' '.
                    $locked_sql.' '.
                    $moved_sql.' '.
                    $reg_sql.'
                    ORDER BY t.topic_last_post_id DESC
                    LIMIT '.$limit;
            
            if (!($result = $db->sql_query($sql))) {
                $error = true;
                trigger_error('General Error: Could not obtain topic information (topics sql) : '.$sql);
            }
            
            $total_topics = 0;
            while($row = $db->sql_fetchrow($result)) {
                if ($auth->acl_get('f_read', $row['forum_id']) !== 0) {
                    $topic_rowset[] = $row;
                    $total_topics++;
                }
            }
            
            $db->sql_freeresult($result);
        } elseif ($so === 'to') {
            $sql = 'SELECT t.*, u.username, u.user_id, u2.username as user2, u2.user_id as id2, t.topic_first_poster_name as post_username, t.topic_first_poster_name AS post_username2, t.topic_time as post_time, f.forum_name
                    FROM ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u, ' .  USERS_TABLE . ' u2, ' . FORUMS_TABLE . ' f
                    WHERE t.topic_poster = u.user_id '.
                    $forum_sql.'
                    AND t.forum_id = f.forum_id
                    AND u2.user_id = t.topic_poster'.' '.
                    $announce_sql.' '.
                    $sticky_sql.' '.
                    $locked_sql.' '.
                    $moved_sql.' '.
                    $reg_sql.'
                    ORDER BY t.topic_time DESC
                    LIMIT '.$limit;
            
            if (!($result = $db->sql_query($sql))) {
                $error = true;
                trigger_error('General Error: Could not obtain topic information (topics sql) : '.$sql);
            }
            
            $total_topics = 0;
            while($row = $db->sql_fetchrow($result)) {
                if ($auth->acl_get('f_read', $row['forum_id']) !== 0) {
                    $topic_rowset[] = $row;
                    $total_topics++;
                }
            }
            
            $db->sql_freeresult($result);
        } else {
            if ($a !== '') {
                if ($a == 'y') {
                    $sql = 'SELECT t.*, u.username, u.user_id, u2.username as user2, u2.user_id as id2, p.post_time, p.post_username, f.forum_name
                            FROM ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u, ' . POSTS_TABLE . ' p, ' . USERS_TABLE . ' u2, ' . FORUMS_TABLE . ' f
                            WHERE t.topic_poster = u.user_id '.
                            $forum_sql.'
                            AND p.post_id = t.topic_last_post_id
                            AND p.poster_id = u2.user_id
                            AND t.forum_id = f.forum_id
                            AND t.topic_type = ' . POST_ANNOUNCE . 
                            $noreply_sql.' '.
                            $startdate_sql.'
                            ORDER BY t.topic_last_post_id DESC
                            LIMIT '.$limit;
                    
                    if ( !($result = $db->sql_query($sql)) ) {
                        $error = true;
                        trigger_error('General Error: Could not obtain topic information (announce sql) : '.$sql);
                    }
                    
                    $topic_rowset = array();
                    $total_announcements = 0;
                    while($row = $db->sql_fetchrow($result)) {
                        if ($auth->acl_get('f_read', $row['forum_id']) !== 0) {
                            $topic_rowset[] = $row;
                            $total_announcements++;
                        }
                    }
                    
                    $db->sql_freeresult($result);
                } else {
                    $error = true;
                    trigger_error('Error: Wrong value for argument (announce)');
                }
            } else {
                $topic_rowset = array();
                $total_announcements = 0;
            }
            
            $limit = $limit - $total_announcements;
            if ($limit < 1) {
                $limit = 0;
            }
            
            if ($limit) {
                $sql = 'SELECT t.*, u.username, u.user_id, u2.username as user2, u2.user_id as id2, p.post_username, p2.post_username AS post_username2, p2.post_time, f.forum_name
                        FROM ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u, ' . POSTS_TABLE . ' p, ' . POSTS_TABLE . ' p2, ' . USERS_TABLE . ' u2, ' . FORUMS_TABLE . ' f
                        WHERE t.topic_poster = u.user_id '.
                        $forum_sql.'
                        AND p.post_id = t.topic_first_post_id
                        AND p2.post_id = t.topic_last_post_id
                        AND t.forum_id = f.forum_id
                        AND u2.user_id = p2.poster_id
                        AND t.topic_type <> ' . POST_ANNOUNCE . 
                        $noreply_sql.' '.
                        $startdate_sql.' '.
                        $sticky_sql.' '.
                        $locked_sql.' '.
                        $moved_sql.' '.
                        $reg_sql.'
                        ORDER BY t.topic_type DESC, t.topic_last_post_id DESC
                        LIMIT '.$limit;
                
                if ( !($result = $db->sql_query($sql)) ) {
                    $error = true;
                    trigger_error('General Error: Could not obtain topic information (topics sql) : '.$sql);
                }
                
                $total_topics = 0;
                while($row = $db->sql_fetchrow($result)) {
                    if ($auth->acl_get('f_read', $row['forum_id']) !== 0) {
                        $topic_rowset[] = $row;
                        $total_topics++;
                    }
                }
                
                $db->sql_freeresult($result);
            }
            
            $total_topics += $total_announcements;
        }
        
        if($total_topics) {
            for($i = 0; $i < $total_topics; $i++) {
                $data[$i]['topic_id'] = $topic_rowset[$i]['topic_id'];
                $data[$i]['topic_last_post_id'] = $topic_rowset[$i]['topic_last_post_id'];
                $data[$i]['topic_title'] = censor_text($topic_rowset[$i]['topic_title']);
                $data[$i]['replies'] = $topic_rowset[$i]['topic_replies'];
                $data[$i]['topic_type'] = $topic_rowset[$i]['topic_type'];
                $data[$i]['forum_id'] = $topic_rowset[$i]['forum_id'];
                $data[$i]['forum_name'] = $topic_rowset[$i]['forum_name'];
                
                $temp = $data[$i]['replies'];
                $data[$i]['replies'] = '';
                
                $r = request_var('r', '');
                if ($r !== '') {
                    if ($r === 'y') {
                        $sr = request_var('sr', '');
                        if ($sr !== '') {
                            if ($sr === 'y') {
                                $data[$i]['replies'] = $temp . ' ' . (($temp == '1')? $lang['REPLY'] : $lang['REPLIES']);
                            } else {
                                $error = true;
                                trigger_error('Error: Wrong value for argument (showrepliesword)');
                            }
                        } else {
                            $data[$i]['replies'] = $temp;
                        }
                    } else {
                        $error = true;
                        trigger_error('Error: Wrong value for argument (replies)');
                    }
                }
                
                $temp = $data[$i]['forum_name'];
                $data[$i]['forum_name'] = '';
                $sfn = request_var('sfn', '');
                if ($sfn !== '') {
                    if ($sfn === 'y') {
                        $data[$i]['forum_name'] = $temp;
                    } else {
                        $error = true;
                        trigger_error('Error: Wrong value for argument (show forum name)');
                    }
                }
                
                $h = request_var('h', '');
                if($data[$i]['topic_type'] == POST_ANNOUNCE) {
                    if ($h !== '') {
                        if (strstr($h, 'a')) {
                            $data[$i]['topic_type'] = '';
                        } else {
                            $data[$i]['topic_type'] = $lang['TOPIC_ANNOUNCEMENT'];
                        }
                    } else {
                        $data[$i]['topic_type'] = $lang['TOPIC_ANNOUNCEMENT'];
                    }
                } else if($data[$i]['topic_type'] == POST_STICKY) {
                    if ($h !== '') {
                        if (strstr($h, 's')) {
                            $data[$i]['topic_type'] = '';
                        } else {
                            $data[$i]['topic_type'] = $lang['TOPIC_STICKY'];
                        }
                    } else {
                        $data[$i]['topic_type'] = $lang['TOPIC_STICKY'];
                    }
                } else {
                    $data[$i]['topic_type'] = '';
                }
                
                if($topic_rowset[$i]['topic_vote']) {
                    if ($h !== '') {
                        if (!strstr($h, 'p')) {
                            $data[$i]['topic_type'] .= ($data[$i]['topic_type'] == '') ? '' : ' ';
                            $data[$i]['topic_type'] .= $lang['TOPIC_POLL'];
                        }
                    } else {
                        $data[$i]['topic_type'] .= ($data[$i]['topic_type']) ? '' : ' ';
                        $data[$i]['topic_type'] .= $lang['TOPIC_POLL'];
                    }
                }
                
                if($topic_rowset[$i]['topic_status'] == ITEM_MOVED) {
                    if ($h !== '') {
                        if (!strstr($h, 'm')) {
                            $data[$i]['topic_type'] .= ($data[$i]['topic_type'] == '') ? '' : ' ';
                            $data[$i]['topic_type'] .= $lang['TOPIC_MOVED'];
                        }
                    } else {
                        $data[$i]['topic_type'] .= ($data[$i]['topic_type'] == '') ? '' : ' ';
                        $data[$i]['topic_type'] .= $lang['TOPIC_MOVED'];
                    }
                    
                    $data[$i]['topic_id'] = $topic_rowset[$i]['topic_moved_id'];
                }
                
                if($topic_rowset[$i]['topic_status'] == ITEM_LOCKED) {
                    if ($h !== '') {
                        if (!strstr($h, 'l')) {
                            $data[$i]['topic_type'] .= ($data[$i]['topic_type'] == '') ? '' : ' ';
                            $data[$i]['topic_type'] .= $lang['TOPIC_LOCKED'];
                        }
                    } else {
                        $data[$i]['topic_type'] .= ($data[$i]['topic_type'] == '') ? '' : ' ';
                        $data[$i]['topic_type'] .= $lang['TOPIC_LOCKED'];
                    }
                }
                
                $data[$i]['last_post_author'] = '';
                $lpb = request_var('lpb', '');
                if ($lpb !== '') {
                    $data[$i]['last_post_author'] = ( $topic_rowset[$i]['id2'] == ANONYMOUS ) ? ( ($topic_rowset[$i]['post_username2'] != '' ) ? $topic_rowset[$i]['post_username2'] . ' ' : $lang['GUEST'] . ' ' ) : $topic_rowset[$i]['user2'];
                    if (is_numeric($lpb)) {
                        if ((int) $lpb === 1) {
                            $data[$i]['last_post_author'] = $lang['LASTPOST_FROM'] . ' ' . $data[$i]['last_post_author'];
                        }
                    }
                }
                
                $data[$i]['last_post_time'] = '';
                if ($lpd !== '') {
                    if (is_numeric($lpd)) {
                        if ((int) $lpd < count($date_formats)) {
                            $data[$i]['last_post_time'] = $user->format_date($topic_rowset[$i]['post_time'], $date_formats[$lpd]);
                        } else {
                            $data[$i]['last_post_time'] = $user->format_date($topic_rowset[$i]['post_time'], $config['default_dateformat']);
                        }
                    } else {
                        $data[$i]['last_post_time'] = $user->format_date($topic_rowset[$i]['post_time'], $config['default_dateformat']);
                    }
                }
                
                $ch = request_var('ch', '');
                if ($ch !== '') {
                    if (is_numeric($ch)) {
                        $max_title_length = (int) $ch;
                        if ($max_title_length > 0) {
                            $trans = get_html_translation_table(HTML_ENTITIES);
                            $trans = array_flip($trans);
                            $data[$i]['topic_title'] = strtr($data[$i]['topic_title'], $trans);
                            if (strlen($data[$i]['topic_title']) > $max_title_length) {
                                $chw = request_var('chw', '');
                                if ($chw !== '') {
                                    if ($chw === 'p') {
                                        $data[$i]['topic_title'] = (strstr(strrev(substr($data[$i]['topic_title'], 0, $max_title_length)), ' ')) ? strrev(strstr(strrev(substr($data[$i]['topic_title'], 0, $max_title_length)), ' ')) . '...' : substr($data[$i]['topic_title'], 0, $max_title_length) . '...';
                                    } else if ($chw === 'n') {
                                        $topic_title_orig = $data[$i]['topic_title'];
                                        $data[$i]['topic_title'] = substr($topic_title_orig, 0, $max_title_length);
                                        $lastpart = substr($topic_title_orig, strlen($data[$i]['topic_title']));
                                        if (strrpos(strrev($lastpart), ' ') === false) {
                                            $data[$i]['topic_title'] = $topic_title_orig;
                                        } else {
                                            $data[$i]['topic_title'] .= substr($lastpart, 0, -(strrpos(strrev($lastpart), ' ')))  . '...';
                                        }
                                    } else {
                                        $data[$i]['topic_title'] = substr($data[$i]['topic_title'], 0, $max_title_length) . '...';
                                    }
                                } else {
                                    $data[$i]['topic_title'] = substr($data[$i]['topic_title'], 0, $max_title_length) . '...';
                                }
                            }
                            
                            $trans = array_flip($trans);
                            $data[$i]['topic_title'] = strtr($data[$i]['topic_title'], $trans);
                        }
                    }
                }
            }
        } else {
            $data = false; // no topics
        }
        
        // On retire l'option du javascript pour des question de temps
        if ($out == 'rss') {
            header("Content-type: text/xml");
            echo generate_rss_header($version);
            
            if ($adv_format && strpos($af_string, '|') !== false) {
                $pos = strpos($af_string, '|');
            } else {
                $pos = false;
            }
            
            if ($data !== false) {
                for($i = 0; $i < $total_topics; $i++) {
                    if ($adv_format) {
                        if ($pos) {
                            $title = substr($af_string, 0, $pos);
                            $title = str_replace('§lbl§', htmlspecialchars(strip_tags($data[$i]['topic_type']), ENT_QUOTES, $lang['ENCODING']), $title);
                            $title = str_replace('§tt§', htmlspecialchars($data[$i]['topic_title'], ENT_QUOTES, $lang['ENCODING']), $title);
                            $title = str_replace('§fn§', htmlspecialchars($data[$i]['forum_name'], ENT_QUOTES, $lang['ENCODING']), $title);
                            $title = str_replace('§rep§', htmlspecialchars($data[$i]['replies'], ENT_QUOTES, $lang['ENCODING']), $title);
                            $title = str_replace('§lpa§', htmlspecialchars($data[$i]['last_post_author'], ENT_QUOTES, $lang['ENCODING']), $title);
                            $title = str_replace('§lpt§', htmlspecialchars($data[$i]['last_post_time'], ENT_QUOTES, $lang['ENCODING']), $title);
                            
                            if ($title == '') {
                                $title = htmlspecialchars($data[$i]['topic_title'], ENT_QUOTES, $lang['ENCODING']);
                            }
                            
                            $desc = substr($af_string, $pos + 1);
                            $desc = str_replace('§lbl§', htmlspecialchars(strip_tags($data[$i]['topic_type']), ENT_QUOTES, $lang['ENCODING']), $desc);
                            $desc = str_replace('§tt§', htmlspecialchars($data[$i]['topic_title'], ENT_QUOTES, $lang['ENCODING']), $desc);
                            $desc = str_replace('§fn§', htmlspecialchars($data[$i]['forum_name'], ENT_QUOTES, $lang['ENCODING']), $desc);
                            $desc = str_replace('§rep§', htmlspecialchars($data[$i]['replies'], ENT_QUOTES, $lang['ENCODING']), $desc);
                            $desc = str_replace('§lpa§', htmlspecialchars($data[$i]['last_post_author'], ENT_QUOTES, $lang['ENCODING']), $desc);
                            $desc = str_replace('§lpt§', htmlspecialchars($data[$i]['last_post_time'], ENT_QUOTES, $lang['ENCODING']), $desc);
                        } else {
                            $item = $af_string;
                            $item = str_replace('§lbl§', htmlspecialchars(strip_tags($data[$i]['topic_type'])), $item);
                            $item = str_replace('§tt§', htmlspecialchars($data[$i]['topic_title'], ENT_QUOTES, $lang['ENCODING']), $item);
                            $item = str_replace('§fn§', htmlspecialchars($data[$i]['forum_name'], ENT_QUOTES, $lang['ENCODING']), $item);
                            $item = str_replace('§rep§', htmlspecialchars($data[$i]['replies'], ENT_QUOTES, $lang['ENCODING']), $item);
                            $item = str_replace('§lpa§', htmlspecialchars($data[$i]['last_post_author'], ENT_QUOTES, $lang['ENCODING']), $item);
                            $item = str_replace('§lpt§', htmlspecialchars($data[$i]['last_post_time'], ENT_QUOTES, $lang['ENCODING']), $item);
                            $title = $item;
                            $desc = '';
                        }
                    } else {
                        $title = htmlspecialchars(strip_tags($data[$i]['topic_type']), ENT_QUOTES, $lang['ENCODING']);
                        $title .= ($data[$i]['topic_type'] == '') ? '' : ' ';
                        $title .= htmlspecialchars($data[$i]['topic_title'], ENT_QUOTES, $lang['ENCODING']);
                        $title .= ($data[$i]['forum_name'] == '') ? '' : ' ' . htmlspecialchars($lang['IN']) . ' ';
                        $title .= htmlspecialchars($data[$i]['forum_name'], ENT_QUOTES, $lang['ENCODING']);
                        $desc = htmlspecialchars($data[$i]['last_post_author'], ENT_QUOTES, $lang['ENCODING']);
                        $desc .= ($data[$i]['last_post_author'] == '') ? '' : ', ';
                        $desc .= htmlspecialchars($data[$i]['last_post_time'], ENT_QUOTES, $lang['ENCODING']);
                        $desc .= ($data[$i]['replies'] == '') ? '' : ' (';
                        $desc .= htmlspecialchars($data[$i]['replies'], ENT_QUOTES, $lang['ENCODING']);
                        $desc .= ($data[$i]['replies'] == '') ? '' : ')';
                    }
                    
                    $jlp = request_var('jlp', '');
                    if ($jlp !== '') {
                        if ($jlp === 'y') {
                            $view_topic_url = $full_url . '/viewtopic.'.$phpEx.'?t=' . $data[$i]['topic_last_post_id'] . '#' . $data[$i]['topic_last_post_id'];
                        } else {
                            $view_topic_url = $full_url . '/viewtopic.'.$phpEx.'?t=' . $data[$i]['topic_id'];
                        }
                    } else {
                        $view_topic_url = $full_url . '/viewtopic.'.$phpEx.'?t=' . $data[$i]['topic_id'];
                    }
                    
                    $title = ($version == '0.91') ? htmlspecialchars(substr(htmlspecialchars_decode($title, ENT_QUOTES), 0, 100), ENT_QUOTES, $lang['ENCODING']) : $title;
                    $link = ($version == '0.91') ? htmlspecialchars(substr(htmlspecialchars_decode($view_topic_url, ENT_QUOTES), 0, 500), ENT_QUOTES, $lang['ENCODING']) : $view_topic_url;
                    $description = ($version == '0.91') ? htmlspecialchars(substr(htmlspecialchars_decode($desc, ENT_QUOTES), 0, 500), ENT_QUOTES, $lang['ENCODING']) : $desc;
                    
                    $item = '<item>' . "\n";
                    $item .= '<title>' . $title . '</title>' . "\n";
                    $item .= '<link>' . $link . '</link>' . "\n";
                    $item .= ($desc != '') ? '<description>' . $description . '</description>' . "\n" : '';
                    $item .= '<dc:date>' . date('Y-m-d\Th:i:s',$topic_rowset[$i]['post_time']). substr_replace(date('O',$topic_rowset[$i]['post_time']),':',3,0) . '</dc:date>' . "\n";
                    $item .= '</item>' . "\n";
                    echo $item;
                }
            } else {
                $title = ($version == '0.91') ? substr($lang['NO_TOPICS'], 0, 100) : $lang['NO_TOPICS'];
                $link = ($version == '0.91') ? substr($full_url, 0, 500) : $full_url;
                
                $item = '<item>' . "\n";
                $item .= '<title>' . $title . '</title>' . "\n";
                $item .= '<link>' . $link . '</link>' . "\n";
                $item .= '</item>' . "\n";
                
                echo $item;
            }
            
            echo generate_rss_footer();
        }
    }
    
    if ($error) {
        trigger_error(print_r($errorarray, true));
    }
} elseif ($mode === 'generate') {
    $htmlstring = $full_url . '/' . TA_SCRIPT_NAME . '.' . $phpEx . '?mode=show';
    
    $out = request_var('out', 'js');
    
    if ($out !== 'js') {
        $htmlstring .= '&out=' . $out;
    }
    
    //$farray = request_var('f', array());
    $farray = $_REQUEST['f'];
    if (count($farray) > 0) {
        foreach ($farray as $f_id) {
            $child = get_forums_child($f_id);
            if (count($child) > 0) {
                $farray = array_merge($farray, $child);
            }
        }
        
        array_unique($farray);
    }
    
    $allfora = request_var('allfora', '');
    if (count($farray) == 0 && $allfora === '') {
        trigger_error($lang['PICK_A_FORUM'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
    } else {
        $total_forums = request_var('total_forums', 0);
        if ($allfora === '1' || ($total_forums === count($farray))) {
            $htmlstring .= '&f=a';
        } else {
            if (count($farray) === 1) {
                $htmlstring .= '&f=' . $farray[0];
            } else {
                $htmlstring .= '&f=u' . rawurlencode(base64_encode(implode(',', $farray)));
            }
        }
    }
    
    $amount_topics = request_var('amount_topics', '');
    if ($amount_topics === '') {
        trigger_error($lang['INVALID_AMOUNT'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
    } else {
        if (!is_numeric($amount_topics)) {
            trigger_error($lang['INVALID_AMOUNT'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
        } else {
            $amount = floor((int) $amount_topics);
            if ($amount > 0) {
                $htmlstring .= '&n=' . $amount;
            } else {
                trigger_error($lang['INVALID_AMOUNT'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
            }
        }
    }
    
    $noreply = request_var('noreply', '');
    if ($noreply !== '') {
        $noreply_timespan = request_var('noreply_timespan', '');
        if ($noreply_timespan === '') {
            trigger_error($lang['INVALID_TIMESPAN'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
        } else {
            if (!is_numeric($noreply_timespan)) {
                trigger_error($lang['INVALID_TIMESPAN'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
            } else {
                $timespan = floor((int) $noreply_timespan);
                if ($timespan > 0) {
                    $noreply_unit = request_var('noreply_unit', '');
                    if ($noreply_unit === 'day') {
                        $timespan = $timespan * 864;
                    } else {
                        $timespan = $timespan * 36;
                    }
                    
                    $htmlstring .= '&hnr=' . $timespan;
                } else {
                    trigger_error($lang['INVALID_TIMESPAN'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
                }
            }
        }
    }
    
    $startdate = request_var('startdate', '');
    if ($startdate !== '') {
        $startdate_timespan = request_var('startdate_timespan', '');
        if ($startdate_timespan === '') {
            trigger_error($lang['INVALID_TIMESPAN'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
        } else {
            if (!is_numeric($startdate_timespan)) {
                trigger_error($lang['INVALID_TIMESPAN'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
            } else {
                $timespan = floor((int) $startdate_timespan);
                if ($timespan > 0) {
                    $startdate_unit = request_var('startdate_unit', '');
                    if ($startdate_unit === 'day') {
                        $timespan = $timespan * 864;
                    } else {
                        $timespan = $timespan * 36;
                    }
                    
                    $htmlstring .= '&hsd=' . $timespan;
                } else {
                    trigger_error($lang['INVALID_TIMESPAN'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
                }
            }
        }
    }
    
    $jump_last_post = request_var('jump_last_post', '0');
    if ($jump_last_post === '1') {
        $htmlstring .= '&jlp=y';
    }
    
    $show_forum_name = request_var('show_forum_name', '0');
    if ($show_forum_name === '1') {
        $htmlstring .= '&sfn=y';
        $link_forum_name = request_var('link_forum_name', '0');
        if ($link_forum_name === '1' && $out == 'js') {
            $htmlstring .= '&fnl=y';
        }
    }
    
    $show_replies = request_var('show_replies', '0');
    if ($show_replies === '1') {
        $htmlstring .= '&r=y';
        $show_replies_word = request_var('show_replies_word', '0');
        if ($show_replies_word === '1') {
            $htmlstring .= '&sr=y';
        }
    }
    
    $show_announce = request_var('show_announce', '0');
    if ($show_announce === '1') {
        $htmlstring .= '&a=y';
    }
    
    $show_sticky = request_var('show_sticky', '0');
    if ($show_sticky === '1') {
        $htmlstring .= '&s=y';
    }
    
    $show_locked = request_var('show_locked', '0');
    if ($show_locked === '1') {
        $htmlstring .= '&l=y';
    }
    
    $show_moved = request_var('show_moved', '0');
    if ($show_moved === '1') {
        $htmlstring .= '&m=y';
    }
    
    $show_regular = request_var('show_regular', '0');
    if ($show_regular === '0') {
        $htmlstring .= '&rt=n';
    }
    
    $hidelabel = request_var('hidelabel', array());
    if (count($hidelabel) > 0) {
        $htmlstring .= '&h=';
        foreach ($hidelabel as $key => $val) {
            $htmlstring .= substr($key, 1, -1);
        }
    }
    
    $sort_order = request_var('sort_order', '');
    if ($sort_order === 'ondate') {
        $htmlstring .= '&so=d';
    } elseif ($sort_order === 'topiconly') {
        $htmlstring .= '&so=to';
    }
    
    if ($out != 'rss') {
        $lastposticon_bullet = request_var('lastposticon_bullet', '0');
        if ($lastposticon_bullet === '1') {
            $htmlstring .= '&b=lpi';
        } else {
            $htmlstring .= '&b=' . request_var('bullet_type', 'non');
        }
    }
    
    $show_lastpostby = request_var('show_lastpostby', '0');
    if ($show_lastpostby === '1') {
        $htmlstring .= '&lpb=' . request_var('lastpostby_format', '0');
    }
    
    $show_lastpostdate = request_var('show_lastpostdate', '0');
    if ($show_lastpostdate === '1') {
        $htmlstring .= '&lpd=' . request_var('lastpostdate_format', '0');
    }
    
    $show_lastposticon = request_var('show_lastposticon', '0');
    if ($show_lastposticon === '1' && $out == 'js') {
        $htmlstring .= '&lpi=y';
    }
    
    $add_break = request_var('add_break', '0');
    if ($add_break == '1' && $out == 'js') {
        $htmlstring .= '&br=y';
    }
    
    $add_blank_line = request_var('add_blank_line', '0');
    if ($add_blank_line === '1' && $out == 'js') {
        $htmlstring .= '&bl=y';
    }
    
    $limit_length = request_var('limit_length', '0');
    if ($limit_length !== '0') {
        if (!is_numeric($limit_length)) {
            trigger_error($lang['INVALID_TITLE_LENGTH'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
        } else {
            $limitlength = floor((int) $limit_length);
            if ($limitlength > 0) {
                $htmlstring .= '&ch=' . $limitlength . '&chw=' . request_var('limit_where', 'p');
            }
        }
    }
    
    $css_link = request_var('css_link', '');
    if ($css_link !== '' && $out == 'js') {
        $css_link = trim($css_link);
        if (preg_match("/[^a-zA-Z0-9]+$/s", $css_link) || strstr($css_link, ' ')) {
            trigger_error($lang['INVALID_CLASS'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
        } else {
            if ($css_link != '') {
                $htmlstring .= '&cl=' . $css_link;
            }
        }
    }
    
    $css_text = request_var('css_text', '');
    if ($css_text !== '' && $out == 'js') {
        $css_text = trim($css_text);
        if (preg_match("/[^a-zA-Z0-9]+$/s", $css_text) || strstr($css_text, ' ')) {
            trigger_error($lang['INVALID_CLASS'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
        } else {
            if ($css_text != '') {
                $htmlstring .= '&ct=' . $css_text;
            }
        }
    }
    
    $target_link = request_var('target_link', '');
    if ($target_link !== '' && $out == 'js') {
        $target_link = trim($target_link);
        if (preg_match("/[^a-zA-Z0-9_]+$/s", $target_link) || strstr($target_link, ' ')) {
            trigger_error($lang['INVALID_TARGET'] . '<br /><br /><a href="javascript:history.back()">' . $lang['CLICK_RETURN'] . '</a>', E_USER_ERROR);
        } else {
            if ($target_link != '') {
                $htmlstring .= '&t=' . $target_link;
            }
        }
    }
    
    $adv_form_enable = request_var('adv_form_enable', '0');
    if ($adv_form_enable === '1') {
        $adv_form = request_var('adv_form', '');
        if ($adv_form !== '') {
            if ($out !== 'js') {
                $htmlstring .= '&af=' . rawurlencode(base64_encode(strip_tags($adv_form)));
            } else {
                if (!class_exists('parse_message')) {
                    include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
                }
                $message_parser = new parse_message($adv_form);
                $message_parser->parse(false, false, false);

                $htmlstring .= '&af=' . rawurlencode(base64_encode($message_parser->message));
            }
        }
    }
    
    if ($out == 'js') {
        $htmlstring = '<script language="JavaScript" type="text/javascript" src="' . $htmlstring . '"></script>';
    }
    
    $page_title = $lang['TOPICS_ANYWHERE'];
    
    if ($out == 'js') {
        $file = 'topics_anywhere_result.html';
        $result = str_replace("&amp;", "&", htmlspecialchars($htmlstring, ENT_QUOTES));
    } else if ($out != 'js') {
        $file = 'topics_anywhere_result_rss.html';
        $result = '<a href="' . $htmlstring . '" target="_blank" class="gen">' . str_replace("&amp;", "&", htmlspecialchars($htmlstring, ENT_QUOTES)) . '</a>';
        $lang['COPY_PASTE'] = $lang['COPY_PASTE_RSS'];
        $lang['COPY_PASTE_EXPLAIN'] = $lang['COPY_PASTE_EXPLAIN_RSS'];
    }
    
    $template->assign_vars(array(
                'L_TOPICS_ANYWHERE' => $lang['TOPICS_ANYWHERE'] . ' ' . TA_VERSION,
                'L_COPYPASTE' => $lang['COPY_PASTE'],
                'L_COPYPASTE_EXPLAIN' => $lang['COPY_PASTE_EXPLAIN'],
                'RESULT' => $result,
                'L_RESULT' => $lang['THE_RESULT'],
                'L_CLASSES_REMARK' => $lang['CLASSES_REMARK'],
                'HTMLCODE' => $htmlstring
    ));
    
    page_header($page_title);
    
    $template->set_filenames(array(
            'body' => $file
    ));
    $template->set_template();
    
    make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));
    page_footer();
    
} else {
    show_the_page();   
}